//License: GNU
//
//
//
//    Jonti's AV Sender
//
//    Copyright (C) 2007  Jonti Olds
//
//
//
//    This program is free software: you can redistribute it and/or modify
//
//    it under the terms of the GNU General Public License as published by
//
//    the Free Software Foundation, either version 3 of the License, or
//
//    (at your option) any later version.
//
//
//
//    This program is distributed in the hope that it will be useful,
//
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//
//    GNU General Public License for more details.
//
//
//
//    You should have received a copy of the GNU General Public License
//
//    along with this program.  If not, see <http://www.gnu.org/licenses/>
//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <SyncObjs.hpp>
#include <Forms.hpp>
#include "uCiaComport.hpp"
#include "WSocket.hpp"
#include "JvAppIniStorage.hpp"
#include "JvAppStorage.hpp"
#include "JvComponentBase.hpp"
#include "JvFormPlacement.hpp"
#include "JvCombobox.hpp"
#include "JvEdit.hpp"
#include "JvExControls.hpp"
#include "JvExStdCtrls.hpp"
#include "JvgLabel.hpp"
#include "JvLabel.hpp"
#include "JvLED.hpp"
#include "JvValidateEdit.hpp"
#include <ExtCtrls.hpp>
#include "JvXPButtons.hpp"
#include "JvXPCore.hpp"
#include "Crc32.h"
#include "JvXPCheckCtrls.hpp"
#include "InterleaverConv.h"
#include "RS.h"
#include <ComCtrls.hpp>

#define WM_DESTROY_SOCKET (WM_USER + 1)
enum PacketType {ptUnReal,ptUnRealHeader};
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TJvAppIniFileStorage *JvAppIniFileStorage1;
        TJvFormStorage *JvFormStorage1;
        TJvLabel *JvLabel7;
        TJvEdit *JvEditUnRealServerAddr;
        TJvValidateEdit *JvValidateEditUnRealServerPort;
        TJvLabel *JvLabel19;
        TJvLabel *JvLabel8;
        TJvEdit *JvEditUnRealAlias;
        TJvLabel *JvLabel21;
        TJvValidateEdit *JvValidateEditUnRealHeaderSendPriod;
        TJvValidateEdit *JvValidateEditUnRealQAMTcpPort;
        TJvLabel *JvLabel20;
        TWSocket *SocketUnRealTCPClient;
        TWSocket *SocketUnRealTCPServerListner;
        TTimer *UnRealHeaderTimer;
        TGroupBox *GroupBox1;
        TJvLabel *JvLabel17;
        TJvLabel *JvLabel18;
        TJvComboBox *JvComboBoxRS232Port;
        TJvComboBox *JvComboBoxRS232Baudrate;
        TJvLED *OverFlowLED;
        TJvgLabel *JvgLabel8;
        TJvLED *UnRealServerLED;
        TJvgLabel *JvgLabel7;
        TJvLED *UnRealClientLED;
        TJvgLabel *JvgLabel5;
        TJvLED *UnRealHeaderLED;
        TJvgLabel *JvgLabel6;
        TJvXPButton *JvXPButtonStart;
        TJvXPButton *JvXPButtonStop;
        TJvLED *ModLED;
        TJvgLabel *JvgLabel1;
        TJvLED *DeModLED;
        TJvgLabel *JvgLabel4;
        TJvXPCheckbox *JvXPCheckboxModOn;
        TJvXPCheckbox *JvXPCheckboxDeModOn;
        TCiaComPort *CiaComPort1;
        TTimer *Timer1;
        TStatusBar *StatusBar1;
        void __fastcall SocketUnRealTCPServerListnerSessionAvailable(
          TObject *Sender, WORD ErrCode);
        void __fastcall SocketUnRealTCPClientSessionConnected(
          TObject *Sender, WORD ErrCode);
        void __fastcall SocketUnRealTCPClientSessionClosed(TObject *Sender,
          WORD ErrCode);
        void __fastcall SocketUnRealTCPClientDataAvailable(TObject *Sender,
          WORD ErrCode);
        void __fastcall UnRealHeaderTimerTimer(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall JvXPButtonStartClick(TObject *Sender);
        void __fastcall JvXPButtonStopClick(TObject *Sender);
        void __fastcall CiaComPort1DataAvailable(TObject *Sender);
        void __fastcall CiaComPort1DataSent(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall JvXPCheckboxModOnClick(TObject *Sender);
        void __fastcall JvXPCheckboxDeModOnClick(TObject *Sender);
private:	// User declarations
protected:
    void __fastcall WMDestroySocket(TMessage Msg);
BEGIN_MESSAGE_MAP
    MESSAGE_HANDLER(WM_DESTROY_SOCKET, TMessage, WMDestroySocket)
END_MESSAGE_MAP(TForm)
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
        TList      *FClients;
        void __fastcall ClientDataAvailable(TObject *Sender, WORD Error);
        void __fastcall ClientSessionClosed(TObject *Sender, WORD Error);

        //for client
        unsigned char UnRealHeader[1000];
        int UnRealHeadersize;
        bool UnRealHeaderGotIt;

        unsigned char QAMUnRealHeader[1000];
        int QAMUnRealHeadersize;
        bool QAMUnRealHeaderGotIt;

        bool mod,demod;

        void __fastcall LoadNextBufferPacket(unsigned char * Buf,int Len,PacketType pt);
        unsigned char packetinbuf[20000];
        int packetinbufptr;
        unsigned char rs232incharbuf[20000];
        bool fullingpacket;
        int packetsize;

        bool sending;
        TCriticalSection *criticalsection;

        void __fastcall SendRs232(unsigned char * Buf,int Len);
        int rs232outcharbufptr;
        unsigned char rs232outcharbuf[20000];

        bool overflowevent;

        RSWrapper rsw;
        __int64  DataXfered,LastDataXfered;
        int DisplayingTextCountdown;


};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
